package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:HuJianGuo
 * @GreateTime:2021/9/23 8:46
 * @Version:V2.0
 */
@FeignClient(value = "DIL-BMSTRUCK-API-DEV", url = "${openfeign.BmstruckFeign.url}")
public interface BmstruckFeign {

    /**
     * 展示汽运详单信息
     *
     * @param mapValue
     * @param pageNum
     * @param pageSize
     * @param apiId
     * @return
     */
    @PostMapping(value = "/api/v1/bmstruck/bmstruckdetailsorder/getTruckDetailsOrderList")
    RESTfulResult getTruckDetailsOrderList(@RequestBody(required = false) Map<String, Object> mapValue,
                                           @RequestParam Integer pageNum,
                                           @RequestParam Integer pageSize,
                                           @RequestParam Integer apiId);

    /**
     * 展示汽运实绩信息
     *
     * @param mapValue
     * @param pageNum
     * @param pageSize
     * @param apiId
     * @return
     */
    @PostMapping(value = "/api/v1/bmstruck/bmstruckdetailsorder/getTruckResultList")
    RESTfulResult getTruckResultList(@RequestBody(required = false) Map<String, Object> mapValue,
                                     @RequestParam Integer pageNum,
                                     @RequestParam Integer pageSize,
                                     @RequestParam Integer apiId,
                                     @RequestParam BigDecimal orderId);

    /**
     * 新增汽运详单
     *
     * @param orderId
     * @return
     */
    @PostMapping(value = "/api/v1/bmstruck/bmstruckdetailsorder/addDetailsOrder/{orderId}")
    RESTfulResult addTruckDetailsOrder(@PathVariable("orderId") BigDecimal orderId);
}