package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/1 17:19
 */

@FeignClient(name = "dil-trick-queue-dev", url = "${openfeign.QmsTruckFeign.url}")
public interface QmsTruckFeign {

    /*
    QmsQueueResultController /  QmsQueueListController
     */

    @PostMapping("api/v1/queueTruck/qmsqueueresults/addQueueResult")
    public RESTfulResult addQueueResult(String orderNumber);


    @PostMapping("api/v1/queueTruck/qmsqueuelists/addQueueList")
    public RESTfulResult addQueueList(@RequestBody(required = false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/orderReceive")
    public RESTfulResult orderReceive(@RequestBody(required=false) Map<String,Object> mapValue,
                                      @RequestParam("apiId") Integer apiId,
                                      @RequestParam("pageNum") Integer pageNum,
                                      @RequestParam("pageSize") Integer pageSize
    );

    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueApply")
    public RESTfulResult getQueueApply(@RequestBody(required=false) Map<String,Object> mapValue,
                                       @RequestParam("apiId") Integer apiId,
                                       @RequestParam("pageNum") Integer pageNum,
                                       @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueListByQueueUp")
    public RESTfulResult getQueueListByQueueUp(@RequestBody(required=false) Map<String,Object> mapValue,
                                               @RequestParam("apiId") Integer apiId,
                                               @RequestParam("pageNum") Integer pageNum,
                                               @RequestParam("pageSize") Integer pageSize,
                                               @RequestParam("gridId") Integer gridId
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/changeQueue")
    public RESTfulResult changeQueue(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getChangeQueue")
    public RESTfulResult getChangeQueue(@RequestBody(required=false) Map<String,Object> mapValue,
                                               @RequestParam("apiId") Integer apiId,
                                               @RequestParam("pageNum") Integer pageNum,
                                               @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueCancel")
    public RESTfulResult queueCancel(@RequestBody(required=false) Map<String, Object> mapValue);



    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueCancel")
    public RESTfulResult getQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue,
                                        @RequestParam("apiId") Integer apiId,
                                        @RequestParam("pageNum") Integer pageNum,
                                        @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueCancelByResultId/{resultId}")
    public RESTfulResult getQueueCancelByResultId(@PathVariable("resultId") Integer resultId);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/updateQueueCancel")
    public RESTfulResult updateQueueCancel(@RequestBody(required=false) Map<String,Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueCutInLine")
    public RESTfulResult queueCutInLine(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueInsert")
    public RESTfulResult getQueueInsert(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/queueEndByPDA")
    public RESTfulResult queueEnd(@RequestBody(required=false) Map<String, Object> mapValue);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueEndResult")
    public RESTfulResult getQueueEndResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueueresults/capacityMonitor")
    public RESTfulResult capacityMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                         @RequestParam("apiId") Integer apiId,
                                         @RequestParam("pageNum") Integer pageNum,
                                         @RequestParam("pageSize") Integer pageSize
    );


    @PostMapping("api/v1/queueTruck/qmsqueuelists/listMonitor")
    public RESTfulResult listMonitor(@RequestBody(required=false) Map<String,Object> mapValue,
                                     @RequestParam("apiId") Integer apiId,
                                     @RequestParam("pageNum") Integer pageNum,
                                     @RequestParam("pageSize") Integer pageSize
    );



    @PostMapping("api/v1/queueTruck/qmsqueueresults/getQueueStatusList")
    public RESTfulResult getQueueStatusList();


    @PostMapping("api/v1/queueTruck/qmsqueueresults/getOrderReceive/{capacityNumber}")
    public RESTfulResult getOrderReceive(@PathVariable("capacityNumber") String capacityNumber);


    @PostMapping("api/v1/queueTruck/qmsqueueresults/cancelQueue")
    public RESTfulResult cancelQueue(@RequestBody Map<String,Object> mapValue);

    @PostMapping("/getAllExecutionOrder")
    public RESTfulResult getAllExecutionOrder(@RequestBody(required=false) Map<String,Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize,
                                              @RequestParam("orderType")Integer orderType,
                                              @RequestParam("status")Integer status
    );

}
