package com.steerinfo.dil.feign;

import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/1 16:19
 */

@FeignClient(name = "dil-tms-train-dev", url = "${openfeign.TmsTrainFeign.url}6")
public interface TmsTrainFeign {

/*
    TmstrainLoadingResultController
 */

    @PostMapping("api/v1/trainTms/tmstrainloadingresults/getTmstrainWagonLoad")
    public RESTfulResult getTmstrainWagonLoad(@RequestBody(required = false) Map<String, Object> mapValue,
                                              @RequestParam("apiId") Integer apiId,
                                              @RequestParam("pageNum") Integer pageNum,
                                              @RequestParam("pageSize") Integer pageSize);


    @PostMapping(value = "api/v1/trainTms/tmstrainloadingresults/insertTmstrainLoadingResult")
    public RESTfulResult insertTmstrainLoadingResult(@RequestBody(required = false) Map<String, Object> map);


    @PostMapping(value = "api/v1/trainTms/tmstrainloadingresults/getTmstrainLoadingResultByResultId/{resultId}")
    public RESTfulResult getTmstrainLoadingResultByResultId(@PathVariable("resultId") BigDecimal resultId);


    @PostMapping(value = "api/v1/trainTms/tmstrainloadingresults/upadteTmstrainLoadingResultByResultId")
    public RESTfulResult upadteTmstrainLoadingResultByResultId(@RequestBody(required = false) Map<String, Object> map);


    @PostMapping(value = "api/v1/trainTms/tmstrainloadingresults/deleteTmstrainLoadingResultByResultId")
    public RESTfulResult deleteTmstrainLoadingResultByResultId(@RequestParam BigDecimal resultId);

    //下拉框

    @GetMapping(value = "api/v1/trainTms/tmstrainloadingresults/getSendStationName")
    public RESTfulResult getSendStationName();


    @GetMapping(value = "api/v1/trainTms/tmstrainloadingresults/getArrivalStationName")
    public RESTfulResult getArrivalStationName();


    @GetMapping(value = "api/v1/trainTms/tmstrainloadingresults/getBatchId")
    public RESTfulResult getBatchId();


    @GetMapping(value = "api/v1/trainTms/tmstrainloadingresults/getWagonNo")
    public RESTfulResult getWagonNo();


    /*
        TmstrainWagonUnloadResultController
     */

    @PostMapping("api/v1/trainTms/tmstrainwagonunloadresults/getTmstrainWagonUnLoad")
    public RESTfulResult getTmstrainWagonUnLoad(@RequestBody(required=false) Map<String,Object> mapValue,
                                                @RequestParam("apiId") Integer apiId,
                                                @RequestParam("pageNum") Integer pageNum,
                                                @RequestParam("pageSize") Integer pageSize);


    @PostMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/deleteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult deleteTmstrainWagonUnLoadResultByUnLoadingId(@RequestParam BigDecimal unloadingId);


    @PostMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/insertTmstrainWagonUnLoadResult")
    public RESTfulResult insertTmstrainWagonUnLoadResult(@RequestBody(required = false) Map<String, Object> tmstrainWagonUnloadResult);


    @PostMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/upadteTmstrainWagonUnLoadResultByUnLoadingId")
    public RESTfulResult upadteTmstrainWagonUnLoadResultByUnLoadingId(@RequestBody(required = false) Map<String, Object> tmstrainWagonUnloadResult);


    @PostMapping("api/v1/trainTms/tmstrainwagonunloadresults/getTmstrainresult")
    public RESTfulResult getTmstrainresult(@RequestBody(required=false) Map<String,Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize);


    @PostMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/getTmstrainWagonUnLoadResultByUnLoadingId/{unloadingId}")
    public RESTfulResult getTmstrainWagonUnLoadResultByUnLoadingId(@PathVariable("unloadingId") BigDecimal unloadingId);


        //下拉框
    @GetMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/getUnloadingPointName")
    public RESTfulResult getUnloadingPointName();


    @GetMapping(value = "api/v1/trainTms/tmstrainwagonunloadresults/getUnloadingRouteName")
    public RESTfulResult getUnloadingRouteName();



    /**************************TmstrainPleaseApproveResultController************************************/

    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/getAllWagonPlease")
    public RESTfulResult getAllWagonPlease(@RequestBody(required=false) Map<String,Object> mapValue,
                                           @RequestParam("apiId") Integer apiId,
                                           @RequestParam("pageNum") Integer pageNum,
                                           @RequestParam("pageSize") Integer pageSize,
                                           @RequestParam("status") Integer status);

    @PostMapping ("api/v1/trainTms/tmstrainpleaseapproveresults/getWagonPleaseById/{resultId}")
    public RESTfulResult getWagonPleaseById(@PathVariable("resultId")Integer resultId);

    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/addWagonPlease")
    public RESTfulResult addWagonPlease(@RequestBody(required = false) Map<String, Object> tmstrainPleaseApproveResult);


    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/updateWagonPlease")
    public RESTfulResult updateWagonPlease(@RequestBody(required = false) Map<String, Object> tmstrainPleaseApproveResult);


    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/deleteWagonPlease/{resultId}")
    public RESTfulResult deleteWagonPlease(@PathVariable("resultId") Integer resultId);


    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/sendWagonPlease/{resultId}")
    public RESTfulResult sendWagonPlease(@PathVariable("resultId") Integer resultId);

    //下拉框
    @GetMapping("api/v1/trainTms/tmstrainpleaseapproveresults/getShipper")
    public RESTfulResult getShipper();

    @GetMapping("api/v1/trainTms/tmstrainpleaseapproveresults/getRailPlan")
    RESTfulResult getRailPlan();


    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/getApproveAllWagonPlease")
    public RESTfulResult getApproveAllWagonPlease(@RequestBody(required=false) Map<String,Object> mapValue,
                                                  @RequestParam("apiId") Integer apiId,
                                                  @RequestParam("pageNum") Integer pageNum,
                                                  @RequestParam("pageSize") Integer pageSize);

    @PostMapping ("api/v1/trainTms/tmstrainpleaseapproveresults/getApproveWagonPleaseById/{resultId}")
    public RESTfulResult getApproveWagonPleaseById(@PathVariable("resultId")Integer resultId);


    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/addApproveWagonPlease")
    public RESTfulResult addApproveWagonPlease(@RequestBody(required = false) Map<String, Object> tmstrainPleaseApproveResult);

    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/updateApproveWagonPlease")
    public RESTfulResult updateApproveWagonPlease(@RequestBody(required = false) Map<String, Object> tmstrainPleaseApproveResult);

    @PostMapping("api/v1/trainTms/tmstrainpleaseapproveresults/deleteApproveWagonPlease/{resultId}")
    public RESTfulResult deleteApproveWagonPlease(@PathVariable("resultId") Integer resultId);
}